<?php

/**
 * install actions: for the sake of simplicity and especially as a security, so this directory can be deleted
 *   once the install is complete, everything will be included in this module.
 *
 * @package    authpuppy
 * @subpackage install
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    $Id$
 */
class installActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeIndex(sfWebRequest $request)
  {
      // Only if the tables in the user's table does not exist or is empty do we allow to access this page without being logged in
      $first = false;
      try {
          $users = Doctrine::getTable('sfGuardUser')
            ->createQuery('a')->count();
          if ($users == 0) {
              $first = true;
          }
      } catch(Exception $e) {
          $first = true;
      }
      if ( (!$first) && (!$this->getUser()->isAuthenticated()) ) {
          $this->context->getController()->forward(sfConfig::get('sf_secure_module'), sfConfig::get('sf_secure_action'));
          throw new sfStopException();          
      } 
      $this->first = $first;
      
      $this->hasEvents = false;
      if ($request->isMethod('post')) {
          $webexec = new apWebExecutor();
      
          if ($request->getParameter("do") == "dataload")
            $webexec->run('sfDoctrineDataLoadTask');
          else {
            $webexec->run('sfDoctrineMigrateTask');
          }
          $this->events = apWebExecutor::getEvents();
          $this->hasEvents = true;
      }
  }
  
  public function executeDb(sfWebRequest $request) {
      $this->form = new apInstallDbForm();
  }
  
  public function executeConfigure(sfWebRequest $request) {
    $this->form = new apConfigurationForm();
    if ($request->isMethod(sfRequest::POST)) {
      $this->form->bind($request->getParameter($this->form->getNameFormat()), $request->getFiles($this->form->getNameFormat()));
      if ($this->form->isValid()) {
        $this->form->save();   
      }
    }
  }
}
