<?php

/**
 * apInstallDb
 * 
 * Base form to enter the database information
 * 
 * 
 * @package    authpuppy
 * @subpackage install
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    $Id$
 */

class apInstallDbForm extends BaseForm
{
  
  /**
   * @see sfForm
   */
  public function setup()
  {   
    $dbchoices = array('mysql', 'postgres');
    
    $this->widgetSchema['dbtype'] = new sfWidgetFormChoice(array(
      'choices'  => $dbchoices,
      'expanded' => false,
    ));
    
    $this->widgetSchema['host'] = new sfWidgetFormInputText();
    $this->widgetSchema['dbname'] = new sfWidgetFormInputText();
    $this->widgetSchema['dbuser'] = new sfWidgetFormInputText();
    $this->widgetSchema['dbpassword'] = new sfWidgetFormInputText();

    $this->setValidators(array(
      'host'   => new sfValidatorString(array('max_length' => 255)),
      'dbname' => new sfValidatorString(array('max_length' => 255)),
      'dbuser' => new sfValidatorString(array('max_length' => 255)),
      'dbpassword' => new sfValidatorString(array('max_length' => 255)),
      'dbtype' => new sfValidatorChoice(array(
          'choices' => $dbchoices,
        )),
    ));
    
    $this->widgetSchema->setNameFormat('installdb[%s]');
  }
  
}