<?php
/**
 * apAuthenticatorManager
 * 
 * Class to manager the available authenticators on this instance
 * Unlike apAuthentication, this class contains methods to get some generic 
 *    information that is not necessarily related to authentication itself, 
 *    but to the authenticators.
 * 
 * @package    authpuppy
 * @subpackage model
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    bzr: $Id$
 */


class apAuthenticatorManager {
  
  protected static $authinterface;
  
  public static function getAuthTypes() {
    if (is_null(self::$authinterface)) {
          $dispatcher = sfProjectConfiguration::getActive()->getEventDispatcher();
    
      $authTypes = array();
      $authTypes = $dispatcher->filter(new sfEvent($dispatcher, 'authenticator.report_interface'), $authTypes);
      self::$authinterface = $authTypes->getReturnValue();
    }
    return self::$authinterface;

  }
}