<?php

/**
 * apIdentity
 * 
 * Default concrete implementation of the identity
 * 
 * @package    authpuppy
 * @subpackage model
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    bzr: $Id$
 */
class apIdentity extends apBaseIdentity
{
  
  /**
   * Save the identity
   * @param $id string|integer
   * @param $identityObject object
   * @return none
   */
  public function identify($id, $identityObject = null, $authenticator = null) {
    if (! ( (is_string($id) || is_int($id))
             && is_object($identityObject) ) ) {
      $this->_identified = false;
      return;
    } 
    if (!$authenticator instanceof apAuthentication)
      return;

    $this->_id = $id;
    $this->_object = $identityObject;
    $this->_identified = true;
    $this->_authenticator = $authenticator;
  }
  
  /**
   * Delete the identity
   * @return none
   */
  public function logout() {
    $this->_id = null;
    $this->_object = null;
    $this->_identified = false;
    $this->_authenticator = null;
  }
  
}