<?php


/**
 * apContext extends the sfContext to add the ability to save the identity of the user on the network
 *
 * @package    authpuppy
 * @subpackage model
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    bzr: $Id$
 */
class apContext extends sfContext
{
  public function loadFactories() {
    parent::loadFactories();
    $this->factories['identity'] = new apIdentity();
  }
  
  /**
   * Retrieve the identity on the network.
   *
   * @return apIdentity The current apIdentity implementation instance.
   */
  public function getIdentity()
  {
    return isset($this->factories['identity']) ? $this->factories['identity'] : null;
  }


}
