<?php

/**
 * A generic mail message class that can be called from anywhere in the application to create new mail
 * message.  This class allows to get partials for mail messages, that wouldn't be possible from model classes
 * and other non action classes.
 *
 * @package    authpuppy
 * @subpackage model
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    bzr: $Id$
 */

class apMailMessage {
  
  protected $mail;
  
  public function __construct() {
    $this->mail = Swift_Message::newInstance();
  }
  
  public function __call($method, $arguments) {
    call_user_func_array(array($this->mail, $method), $arguments);
    return $this;
  }
  
  /**
   * Gets the body of a message from a partial
   * @param string $partialName
   * @param array $arguments
   */
  public function setBodyFromPartial($partialName, $arguments) {
    sfContext::getInstance()->getConfiguration()->loadHelpers(array('Partial'));
    $content = get_partial($partialName, $arguments);
    $this->mail->setBody($content);  
    return $this; 
  }
  
  public function getMailMessage() {
    return $this->mail;
  }
}