<?php

/**
 * Utility class providing generic methods that can be reused throughout the application
 *
 * @package    authpuppy
 * @subpackage model
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    bzr: $Id$
 */


class apUtils {
  
  /**
   * Generate a random 32 characters nonce
   * @return string
   */
  public static function generateNonce() {
    return sha1(rand() . time());
  }
  
  public static function displayDuration($difftime) {
    if (!is_int($difftime)) {
      return $difftime;
    }
     // Format the time difference in the most appropriate format
    $format = "i\m s";
    if ($difftime > 60*60) {
      $format = "h\h ". $format;
      if ($difftime > 60*60*24) {
        $format = "z\d " . $format;
      }
    } 
    
    return gmdate($format, $difftime);
  } 
}