<?php

class NodeTable extends Doctrine_Table
{
    static public $statuses = array(
        "IN_PLANNING" => "In planning",
        "DEPLOYED" => "Deployed",
        "IN_TESTING" => "In testing",
        "NON_WIFIDOG_NODE" => "Non-Wifidog node",
        "PERMANENTLY_CLOSED" => "Permanently closed",
        "TEMPORARILY_CLOSED" => "Temporarily closed",
    ); 

    public function getActiveNodes() {
      # Return all nodes for now
      $q = $this->createQuery('n');

      return $q->execute();
    }
    
    /**
     * 
     * Return all nodes
     */
    public function getNodes() {
      $q = $this->createQuery('n');
      return $q->execute();
    }
    
    public function getDeployedNodes() {
      # Return only deployed nodes
      $q = $this->createQuery('n')
        ->where('n.deployment_status = ?', "DEPLOYED");

      return $q->execute();
    }
    
    public function getDeploymentStatuses() {
      return self::$statuses;
    }

}
