<?php

/**
 * apPluginManagerConfigurationForm
 * 
 * Base form to configure values of a plugin
 * 
 * 
 * @package    authpuppy
 * @subpackage apPluginManager
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    $Id$
 */

abstract class apPluginManagerConfigurationForm extends BaseForm
{
  protected $plugin;
  protected $namespace = 'appmconfigure';
  
  /**
   * @see sfForm
   */
  public function setup()
  {   
    $this->widgetSchema->setNameFormat($this->namespace . '[%s]');
  }
  
  public function save() {
    
    // Set the state of every plugin
    foreach ($this->getWidgetSchema()->getFields() as $name => $element) {
      if (!$element->isHidden()) {
        $this->plugin->setConfigOption($name, $this->getValue($name));
      }
    } 
  }
  
  public function getNameFormat() {
    return $this->namespace;
  }
  
  public function setPlugin(apPlugin $plugin) {
    $this->plugin = $plugin;
  }
  public function getPlugin() {
    return $this->plugin;
  }
  public function getPartial() {
    return "apPluginManager/formConfigure";
  }
  
  public function findDefaults() {
    // Set the state of every plugin
    foreach ($this->widgetSchema as $name => $element) {
      if (!$element->isHidden()) {
        $this->setDefault($name, $this->plugin->getConfigOption($name));
      }
    }
  }
}