<?php use_stylesheets_for_form($form) ?>
<?php use_javascripts_for_form($form) ?>

<?php print form_tag('@ap_pluginmanager_save');?>
  <table>
    <thead>
      <tr>
        <th>Plugin name</th>
        <th>Database update required?</th>
        <th>Enabled?</th>
      </tr>
    </thead>
    <tbody>
      <?php foreach ($form->getPlugins() as $pluginName => $plugin): 
          $info = $plugin->getPluginInfo();
          $version = null; $stability = null;
          if (isset($info['version'])) $version = $info['version'];
          if (isset($info['stability'])) $stability = $info['stability'];
        ?>
      	<tr>
          <th><?php echo (($route = $plugin->getConfigRoute()) ? link_to($pluginName, $route,  $plugin):$pluginName)?><br/> 
               <?php echo (!is_null($version)? __("version") . ": " .$version:'') . (!is_null($stability)?" (".$stability.")":"")?></th>
      	  <td><?php echo ($plugin->getCurrentMigrationVersion() == $plugin->getLatestMigrationVersion() ? __("No upgrade") : __("Yes ") . link_to('upgrade', 'ap_plugin_dbupgrade', $plugin)); ?>
          </td>
      	  <td><?php echo $form[$pluginName]; ?></td>
        </tr>
      <?php endforeach ?>
    </tbody>
    <tfoot>
      <tr>
        <td colspan="3">
          <?php echo $form->renderHiddenFields();?>
          <input type="submit" value="Save" />
        </td>
      </tr>
    </tfoot>
  </table>
</form>

